

public class BarCodeReader
  {
  private AnOrder order;
  private int phase;
  boolean orderFinished;
  String currentBarCode;

  public BarCodeReader()
    {
    order=new AnOrder();
    currentBarCode="";
    phase=0;//Phase should be enumarated;
            //but Java does not support this feature.
    orderFinished=false;
    }

  private void processCurrentBarCode()
    {
    //Bar Code format...
    //AABBB or ABBB where A = Ref Code, Either C0 or C
    //BBB = ID code
    int barcodeValue,ref=0,id=0;
    System.out.println("PHASE: "+phase);
    if(currentBarCode.length()==0) return;
    if(currentBarCode.length()>5) currentBarCode=currentBarCode.substring(currentBarCode.length()-5,currentBarCode.length());
    System.out.println("Barcode received:"+currentBarCode);
    barcodeValue=Integer.parseInt(currentBarCode);
    ref=barcodeValue/1000;
    id=barcodeValue-ref*1000;
    if(ref>9) ref/=10;
    System.out.println("Barcode processed as: ref-"+ref+" and id-"+id);
    handleNewBarCode(ref,id);
    currentBarCode="";
    }

  private void handleNewBarCode(int ref, int id)
    {
    if(!orderFinished)
      {
      switch(ref)
        {
        case 0: barcodeWaitress(id);break;// do while phase=1
        case 1:
        case 2:
        case 3:  //All references here are handled by barcodeItem()
        case 4:
        case 5:
        case 6:
        case 7: barcodeItem(id);    break;
        case 8: barcodeTable(id);   break;// do while phase=0
        case 9: barcodeSystem(id);  break;// at any time
        default: System.out.println("BARCODE UNRECOGNISED!");
        }
      }
      else
      if(ref==9) barcodeSystem(id);
    }

  private void barcodeItem(int id)
    {
    System.out.println("Item "+id+" received!");
    if(phase!=2||orderFinished) return;
    System.out.println("Command done!");
    order.addMeal(Integer.toString(id),"");
    }

  private void barcodeWaitress(int id)
    {
    System.out.println("Waitress "+id+" received!");
    if(phase!=0) return;
    System.out.println("Command done!");
    phase=1;
    order.setWaitressID(String.valueOf(id));
    }

  private void barcodeTable(int id)
    {
    System.out.println("Table "+id+" received!");
    if(phase!=1) return;
    System.out.println("Command done!");
    phase=2;
    order.setTableID(String.valueOf(id));
    }

  private void barcodeSystem(int id)
    {
    switch(id)
      {
      case 0: barcodeDeleteLastItem();break;
      case 1: barcodeDeleteOrder();   break;
      case 2: barcodeOrderFinished(); break;
      }
    }

  private void barcodeOrderFinished()
    {
    System.out.println("ORDER FINISHED!");
    if(phase!=2||order.getNumberOfMeals()==0) return;
    System.out.println("Command done!");
    orderFinished=true;
    }

  private void barcodeDeleteOrder()
    {
    System.out.println("ORDER DELETED!");
    phase=0;
    order.deleteOrder();
    orderFinished=false;
    }

  private void barcodeDeleteLastItem()
    {
    System.out.println("LAST ITEM DELETED!");
    order.deleteMeal();
    }

  //check for a finished order
  public boolean orderFinished()
    {
    return(orderFinished);
    }

  //Return the order using standard protocol
  public String getOrder()
    {
    String message="newOrder:",extras;
    //Table number, waitress number
    message+= order.getTableID()+","+
              order.getWaitressID();
    for(int j=0;j<order.getNumberOfMeals();j++)
      {
      message+= ","+order.getMeal(j);
      extras=order.getExtras(j);
      if(!extras.equals("")) message+=","+extras;
      }
    order.deleteOrder();
    phase=0;
    orderFinished=false;
    return(message);
    }

  //Add another character to the barcode
  public void addNextCharacter(char ch)
    {
    if(ch!=10)
      {
      if(ch>=48&&ch<=57)
        {
        System.out.println((char)ch);
        currentBarCode+=ch;
        }
      return;
      }
    processCurrentBarCode();
    }
  }