import java.awt.*;
import java.awt.geom.*;

public class CurrentOrderDisplay
  {
  int orderOffset=0, cursor=-1;
  RawDataHandler orderInfo;
  int hover=-1;
  GradientPaint orderPaint=new GradientPaint(20,5,new Color(255,255,255,80),145,5,new Color(255,255,255,20),true),
                timePaint=new GradientPaint(235,5,new Color(255,255,255,80),345,5,new Color(255,255,255,20),true),
                tablePaint=new GradientPaint(427,5,new Color(255,255,255,80),497,5,new Color(255,255,255,20),true),
                waitressPaint=new GradientPaint(584,5,new Color(255,255,255,80),654,5,new Color(255,255,255,20),true);

  FontMetrics FM;

  public CurrentOrderDisplay()
    {
    }

  public void setMetaInformation(RawDataHandler data)
    {
    orderInfo=data;
    }

  public void setHover(int h)
    {
    hover=h;
    }

  public void drawDisplay(Graphics g)
    {
    Graphics2D g2d=(Graphics2D) g;
    int startRecord,endRecord;
    //Clear the background
    g.setClip(10,10,695,510);//Clip to the display
    g.setFont(new Font("Ariel",Font.PLAIN,20));
    FM=g.getFontMetrics();
    g.setColor(new Color(50,70,50));
    g.fill3DRect(10,10,695,250,true);//Draw the display background box
    g.translate(20,45);

    //Draw the columns
    g2d.setPaint(orderPaint);
    g2d.fillRect(20,5,125,195);//Order number
    g2d.setPaint(timePaint);
    g2d.fillRect(235,5,110,195);//Time waiting
    g2d.setPaint(tablePaint);
    g2d.fillRect(427,5,70,195);//Table
    g2d.setPaint(waitressPaint);
    g2d.fillRect(584,5,70,195);//Waitress*/

    //Draw the rows
    for(int row=0;row<5;row++)
      {
      g2d.setPaint(new GradientPaint(20,5+row*40,new Color(255,255,255,120),20,40+row*40,new Color(200,200,200,0),true));
      g2d.fillRect(20,5+row*40,635,35);//Top row
      }
    g.setColor(new Color(230,255,230));
    g.drawString("ORDER NUMBER         TIME WAITING            TABLE            WAITRESS",0,-5);
    g.setColor(new Color(255,255,255));
    for(int disp=orderOffset+1;disp<(orderInfo.records+1)&&(disp<orderOffset+6); disp++)
      {
      //Draw Order number
      if(orderInfo.getDataItem(disp,"Ready").equals("1"))
          {
          g.setColor(new Color(0,255,0));
          drawCentre("READY",189,(disp-orderOffset)*40-10,g);
          g.setColor(new Color(255,255,255));
          }
      drawCentre(disp+" : "+orderInfo.getDataItem(disp,"Order ID"),80,(disp-orderOffset)*40-10,g);
      //Draw the time waiting
      int totalSeconds=Integer.parseInt(orderInfo.getDataItem(disp,"Time Waiting"));
      int hours=totalSeconds/60;
      int mins=totalSeconds-(hours*60);
      drawCentre((hours<10?"0":"")+hours+":"+(mins<10?"0":"")+mins,290,(disp-orderOffset)*40-10,g);
      //Draw the Table
      drawCentre(orderInfo.getDataItem(disp,"Table ID"),463,(disp-orderOffset)*40-10,g);
      //Draw the waitress
      drawCentre(orderInfo.getDataItem(disp,"Waitress ID"),620,(disp-orderOffset)*40-10,g);
      }
    g.translate(-20,-45);
    }

  public void setCursor(int index)
    {
    if(index>=orderInfo.records) index=orderInfo.records-1;
    if(index==0) index=-1;
    cursor=index;
    }

  public int getCursor()
    {
    return(cursor);
    }

  public String getOrderIDOne()
    {
    if(orderInfo.records==-1)
      return null;
      else
      return orderInfo.getDataItem(1,"Order ID");
    }

  public String getOrderIDAtCursor()
    {
    if(cursor==-1)
      return null;
      else
      return orderInfo.getDataItem(cursor+orderOffset+1,"Order ID");
    }

  public void drawCentre(String s,int x,int y,Graphics g)
    {
    int newX=x-(FM.stringWidth(s)/2);
    g.drawString(s,newX,y);
    }

  }