import java.awt.*;

public class NewOrderDisplay
  {
  RawDataHandler itemData;

  public NewOrderDisplay()
    {
    }

  public void setItemData(RawDataHandler itemData)
    {
    this.itemData=itemData;
    }

  public String getItemName(int itemID)
    {
    String itemIDS=Integer.toString(itemID);
    for(int index=1;index<=itemData.records;index++)
      {
      if(itemData.getDataItem(index,"Item ID").equals(itemIDS))
        {
        return(itemData.getDataItem(index,"Name"));
        }
      }
    return("Invalid ID!");
    }

  public void drawDisplay(Graphics g,AnOrder currentOrder)
    {
    Graphics2D g2d=(Graphics2D) g;
    int startRecord,endRecord;
    float price=0;
    if(currentOrder.getNumberOfMeals()<4)
      {
      startRecord=0;
      endRecord=currentOrder.getNumberOfMeals();
      }
      else
      {
      endRecord=currentOrder.getNumberOfMeals();
      startRecord=endRecord-4;
      }
    //Clear the background
    g.setClip(10,10,695,510);//Clip to the display
    g.setFont(new Font("Ariel",Font.PLAIN,20));
    g.setColor(new Color(50,70,50));
    g.fill3DRect(10,10,695,250,true);//Draw the display background box
    g.translate(20,45);

    //Draw the rows
    for(int row=0;row<5;row++)
      {
      if(row!=4)
        g2d.setPaint(new GradientPaint(20,5+row*40,new Color(255,255,255,120),20,40+row*40,new Color(200,200,200,0),true));
        else
        g2d.setPaint(new GradientPaint(20,5+row*40,new Color(0,255,0,170),20,40+row*40,new Color(100,255,100,0),true));
      g2d.fillRect(20,5+row*40,635,35);//Top row
      }
    g.setColor(new Color(230,255,230));
    g.drawString("ENTERING NEW ORDER",220,-5);
    g.setColor(new Color(255,255,255));
    if(currentOrder.getNumberOfMeals()==0)
      g.drawString("NO DETAILS ENTERED ",230,110);
      else
      {
      for(int i=0;i<currentOrder.getNumberOfMeals();i++)
        {
        price+=Float.parseFloat((itemData.getDataItem(Integer.parseInt(currentOrder.getMeal(i)),"Price")));
        }
      }
    for(int disp=startRecord;disp<endRecord; disp++)
      {
      g.drawString((disp+1)+" : "+itemData.getDataItem(Integer.parseInt(currentOrder.getMeal(disp)),"Name"),80,(disp-startRecord)*40+30);
      g.drawString(""+itemData.getDataItem(Integer.parseInt(currentOrder.getMeal(disp)),"Price"),550,(disp-startRecord)*40+30);
      }
    g.drawString("Waitress: N/A               Table: N/A",50,190);
    g.drawString("Total: "+price,495,190);
    g.translate(-20,-45);
    }


  }