import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.image.*;

public class Kitchen extends JApplet implements ActionListener
  {
  boolean isStandalone = false, _LIVE_SERVER=true;
  public static final int _DISP_currentOrders=0, _DISP_newOrder=1;
  int stage=_DISP_currentOrders;
  int hover=0,oldHover=0;
  KitchenNetworkCore server;
  BufferedImage buffImage=new BufferedImage(715,520,BufferedImage.TYPE_INT_RGB);
  Graphics buffImageHandle=buffImage.getGraphics();
  XYLayout xYLayout1 = new XYLayout();
  OrderDetailBox leftBox,rightBox;
  CurrentOrderDisplay currentOrderDisplay= new CurrentOrderDisplay();
  Timer timer;

  public void actionPerformed(ActionEvent e)
    {
    refreshWindow();
    redrawWindow();
    }

  public boolean mouseMove(Event e,int x,int y)
    {
    oldHover=hover;
    x-=20;y-=50;
    int cursor=y/40;
    if(cursor<1) cursor=-1;
    if(cursor>5) cursor=-1;
    currentOrderDisplay.setHover(cursor);
    hover=cursor;
    if(hover!=oldHover) redrawWindow();
    return true;
    }

  public void refreshWindow()
    {
    server.sendMessage("getCurrentOrderList");
    currentOrderDisplay.setMetaInformation(new RawDataHandler(server.getMessage()));
    }

  public boolean mouseDown(Event e,int x,int y)
    {
    String ordID="";
    if(y<255)
      {
      if((e.modifiers&4)==4)
        {
        int tempCursor=currentOrderDisplay.getCursor();
        x-=20;y-=50;
        int cursor=y/40;
        if(cursor<0) cursor=0;
        if(cursor>4) cursor=4;
        currentOrderDisplay.setCursor(cursor);
        if(cursor==0)
          ordID=currentOrderDisplay.getOrderIDOne();
          else
          ordID=currentOrderDisplay.getOrderIDAtCursor();
        server.sendMessage("getOrderReady:"+ordID);
        boolean orderIsReady=new RawDataHandler(server.getMessage()).getDataItem(1,"Ready").equals("1");
        if(orderIsReady)
          server.sendMessage("orderNotReady:"+ordID);
          else
          server.sendMessage("orderReady:"+ordID);
        server.getMessage();
        currentOrderDisplay.setCursor(tempCursor);
        refreshWindow();

        updateBoxes();
        }
        else
        {
        x-=20;y-=50;
        int cursor=y/40;
        if(cursor<1) cursor=1;
        if(cursor>5) cursor=5;
        currentOrderDisplay.setCursor(cursor);
        refreshWindow();
        updateBoxes();
        }
      }
      else
      {
      String ID;
      if((e.modifiers&4)==4)
        {
        if((ID=(x<344)?leftBox.getOrder():rightBox.getOrder())!=null)
          {
          server.sendMessage("getOrderReady:"+ID);
          boolean orderIsReady=new RawDataHandler(server.getMessage()).getDataItem(1,"Ready").equals("1");
          if(orderIsReady)
            server.sendMessage("orderNotReady:"+ID);
            else
            server.sendMessage("orderReady:"+ID);
          server.getMessage();
          refreshWindow();
          updateBoxes();
          }
        }
        else
        {
        if((ID=(x<344)?leftBox.getOrder():rightBox.getOrder())!=null)
          {
          server.sendMessage("orderCompleted:"+ID);
          server.getMessage();
          currentOrderDisplay.setCursor(0);
          refreshWindow();
          updateBoxes();
          }
        }
      }
    redrawWindow();
    return true;
    }

  //Construct the applet
  public Kitchen() throws Exception
    {
    String raw;
    if(_LIVE_SERVER)
      {
      server=new KitchenNetworkCore();
      server.sendMessage("getCurrentOrderList");
      raw=server.getMessage();
      }
      else
      {
      //WILL throw an exception when a refresh event occurs.
      raw="6\n5\nOrder ID,Table ID,Time Waiting,Waitress ID,Completed\n1010,15,15,2,0\n1011,12,8,3,0\n";
      raw+="1018,15,15,2,0\n1019,12,8,3,0\n1020,12,8,3,0\n1021,12,8,3,0\n1023,12,8,3,0\n";
      }
    currentOrderDisplay.setMetaInformation(new RawDataHandler(raw));
    server.sendMessage("getMenuList");
    raw=server.getMessage();
    leftBox=new OrderDetailBox("CLICK ORDERS TO DISPLAY",raw);
    rightBox=new OrderDetailBox("CLICK ORDERS TO DISPLAY",raw);
    redrawWindow();
    start();
    }

  public void paint(Graphics window)
    {
    //This method is called automatically when an obstructed window is revealed
    window.drawImage(buffImage,0,0,null);
    }

  public void redrawWindow()
    {
    clearWindow();
    drawDisplay();
    drawButtons();
    drawBoxes();
    buffImageHandle.translate(-20,-45);
    repaint();
    }

  public void update(Graphics g)
    {
    //This method is called automatically when we request a repaint operation.
    paint(g);
    }

  public void clearWindow()
    {
    buffImageHandle.setColor(new Color(0,20,0));
    buffImageHandle.fillRect(0,0,715,520);
    }

  public void drawDisplay()
    {
    switch(stage)
      {
      case _DISP_currentOrders :  currentOrderDisplay.drawDisplay(buffImageHandle);
                                  break;
      }                                              //by martin castaldo
    }

  public void updateBoxes()
    {
    if(currentOrderDisplay.orderInfo.records==0)
      {
      leftBox.setOrder(null);
      leftBox.setTitle("No Orders!");
      rightBox.setTitle("No Orders!");
      rightBox.setOrder(null);
      leftBox.setText(null);
      rightBox.setText(null);
      }
    if(currentOrderDisplay.orderInfo.records==1)
      {
      String leftOrderID=currentOrderDisplay.orderInfo.getDataItem(1,"Order ID");
      leftBox.setTitle("Order "+leftOrderID);
      leftBox.setOrder(leftOrderID);
      server.sendMessage("getOrderDetails:"+leftOrderID);
      leftBox.setText(server.getMessage());
      rightBox.setOrder(null);
      rightBox.setTitle("No 2nd Order!");
      rightBox.setText("...");
      }
    if(currentOrderDisplay.orderInfo.records==2)
      {
      String leftOrderID=currentOrderDisplay.orderInfo.getDataItem(1,"Order ID");
      String rightOrderID=currentOrderDisplay.orderInfo.getDataItem(2,"Order ID");
      server.sendMessage("getOrderDetails:"+leftOrderID);
      leftBox.setOrder(leftOrderID);
      leftBox.setText(server.getMessage());
      server.sendMessage("getOrderDetails:"+rightOrderID);
      rightBox.setText(server.getMessage());
      rightBox.setOrder(rightOrderID);
      leftBox.setTitle("Order "+leftOrderID);
      rightBox.setTitle("Order "+rightOrderID);
      }
    if(currentOrderDisplay.orderInfo.records>2)
      {
      String leftOrderID=currentOrderDisplay.orderInfo.getDataItem(1,"Order ID");
      server.sendMessage("getOrderDetails:"+leftOrderID);
      leftBox.setText(server.getMessage());
      leftBox.setOrder(leftOrderID);
      leftBox.setTitle("Order "+leftOrderID);
      if(currentOrderDisplay.getOrderIDAtCursor()!=null)
        {
        String rightOrderID=currentOrderDisplay.getOrderIDAtCursor();
        server.sendMessage("getOrderDetails:"+rightOrderID);
        rightBox.setOrder(rightOrderID);
        rightBox.setText(server.getMessage());
        rightBox.setTitle("Order "+rightOrderID);
        }
        else
        {
        rightBox.setTitle("No Order Selected!");
        rightBox.setText(null);
        rightBox.setOrder(null);
        }
      }
    }

  public void drawBoxes()
    {
    leftBox.drawOrderDetailBox(5,210,buffImageHandle);
    rightBox.drawOrderDetailBox(344,210,buffImageHandle);
    }

  public void drawButtons()
    {
    }

  //Initialize the applet
  public void init()
    {
    try
      {
      jbInit();
      }
    catch(Exception e)
      {
      e.printStackTrace();
      }
    }

  //Component initialization
  private void jbInit() throws Exception
    {
    this.getContentPane().setBackground(Color.black);
    this.setSize(715,520);
    }

  //Start the applet
  public void start()
    {
    if(timer==null)
      {
      System.err.println("Creating primary timer.");
      timer=new Timer(10000,this);
      timer.start();
      }
    }

  //Stop the applet
  public void stop()
    {
    }

  //Destroy the applet
  public void destroy()
    {
    }

  //Get Applet information
  public String getAppletInfo() {
    return "Applet Information";
  }

  // static initializer for setting look & feel
  static
    {
    try
      {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      //UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
    }
    catch (Exception e) {}
  }

}
