package Server;

/*

This class connects to the database, and receives messages from the server.
It responds with information out of the database.

*/

import java.io.*;
import java.net.*;
import java.awt.*;
import com.borland.dx.sql.dataset.*;
import java.sql.*;
import java.util.*;

public class MessageHandler
  {
  private MessagePacket MPS=new MessagePacket();

  private Database database = new Database();
  private QueryDataSet queryDataSet = new QueryDataSet();
  private Connection con;
  private ResultHandler results=new ResultHandler();
  private TextArea display;

  private void checkForWarnings(SQLWarning warn) throws Exception
    {
    if(warn!=null)
      {
      display.append("***** A WARNING OCCURED *****");
      }
    }

  public MessageHandler(TextArea display) throws Exception
    {
    this.display=display;
    display.append("Opening ODBC connection for database access...");
    String URL="jdbc:odbc:GPD.mdb";
    Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
//    DriverManager.setLogStream();
    con=DriverManager.getConnection(URL,"","");
    checkForWarnings(con.getWarnings());
    DatabaseMetaData dma=con.getMetaData();
    display.append("DONE\n");
    display.append("Connected to: "+dma.getURL()+"\n");
    display.append("Driver: "+dma.getDriverName()+"\n");
    display.append("Version: "+dma.getDriverVersion()+"\n\n");
    }

  public MessagePacket processMessage(MessagePacket packet) throws Exception
    {
    if(packet==null) return null;
    if(packet.message.equals("getMenuItem"))          return(MPS.newMessagePacket(packet.messageID,getMenuItem(packet.data)));
    if(packet.message.equals("getMenuList"))          return(MPS.newMessagePacket(packet.messageID,getMenuList()));
    if(packet.message.equals("getCurrentOrderList"))  return(MPS.newMessagePacket(packet.messageID,getCurrentOrderList()));
    if(packet.message.equals("getOrderDetails"))      return(MPS.newMessagePacket(packet.messageID,getOrderDetails(packet.data)));
    if(packet.message.equals("getDrinkList"))         return(MPS.newMessagePacket(packet.messageID,getDrinkList()));
    if(packet.message.equals("getMainMealList"))      return(MPS.newMessagePacket(packet.messageID,getMainMealList()));
    if(packet.message.equals("getSideOrderList"))     return(MPS.newMessagePacket(packet.messageID,getSideOrderList()));
    if(packet.message.equals("getDessertList"))       return(MPS.newMessagePacket(packet.messageID,getDessertList()));
    if(packet.message.equals("orderCompleted"))       {orderCompleted(packet.data); return(MPS.newMessagePacket(packet.messageID,"Order "+packet.data+" Completed"));}

    if(packet.message.equals("orderReady"))           {orderReady(packet.data); return(MPS.newMessagePacket(packet.messageID,"Order "+packet.data+" Ready"));}
    if(packet.message.equals("orderNotReady"))        {orderNotReady(packet.data); return(MPS.newMessagePacket(packet.messageID,"Order "+packet.data+" Not Ready"));}
    if(packet.message.equals("getOrderReady"))        return(MPS.newMessagePacket(packet.messageID,getOrderReady(packet.data)));

    if(packet.message.equals("DirectSQL-Update"))     {directSQLUpdate(packet.data); return(MPS.newMessagePacket(packet.messageID,"Internal Command OK"));}

    if(packet.message.equals("newOrder"))             {newOrder(packet.data); return(MPS.newMessagePacket(packet.messageID,"New Order Placed!"));}

    display.append("UNKNOWN COMMAND!!!\n....ABOVE COMMAND HAS NOT BEEN ");
    return(MPS.newMessagePacket(packet.messageID,"Unknown command!"));
    }

  public void newOrder(String rawOrderData) throws Exception
    {
    String waitressID,tableID;
    int thisOrderID=0;
    StringTokenizer data=new StringTokenizer(rawOrderData,",");
    tableID=data.nextToken();
    waitressID=data.nextToken();
    directSQLUpdate("INSERT INTO tblCurrentOrder ([Table ID],[Waitress ID]) VALUES ("+tableID+","+waitressID+")");
    ResultSet currentOrders=con.createStatement().executeQuery("SELECT [Order ID] FROM [tblCurrentOrder] WHERE NOT Completed=Yes");
    while(currentOrders.next())
      thisOrderID=Integer.parseInt(currentOrders.getString("Order ID"));
		while(data.hasMoreTokens())
      directSQLUpdate("INSERT INTO tblOrderDetails ([Order ID],[Item ID]) VALUES ("+thisOrderID+","+data.nextToken()+")");
    }

  public void directSQLUpdate(String SQLStatement) throws Exception
    {
    con.createStatement().executeUpdate
      (
      SQLStatement
      );
    }

  public String getOrderReady(String order) throws Exception
    {
    return
      (
      results.newResultSet
        (
        con.createStatement().executeQuery
          (
          "SELECT Ready FROM [tblCurrentOrder] WHERE \"Order ID\" = "+order
          )
        )
      );
    }

  public void orderReady(String orderID) throws Exception
    {
    con.createStatement().executeUpdate
      (
      "UPDATE tblCurrentOrder SET Ready=Yes WHERE [Order ID]="+orderID
      );
    }

  public void orderNotReady(String orderID) throws Exception
    {
    con.createStatement().executeUpdate
      (
      "UPDATE tblCurrentOrder SET Ready=No WHERE [Order ID]="+orderID
      );
    }

  public void orderCompleted(String orderID) throws Exception
    {
    con.createStatement().executeUpdate
      (
      "UPDATE tblCurrentOrder SET Completed=Yes WHERE [Order ID]="+orderID
      );
    }

  public String getMenuItem(String item) throws Exception
    {
    return
      (
      results.newResultSet
        (
        con.createStatement().executeQuery
          (
          "SELECT * FROM [tblMenuItems] WHERE \"Item ID\" = "+item
          )
        )
      );
    }

  public String getMenuList() throws Exception
    {
    return
      (
      results.newResultSet
        (
        con.createStatement().executeQuery
          (
          "SELECT * FROM [tblMenuItems]"
          )
        )
      );
    }

  public String getSideOrderList() throws Exception
    {
    return
      (
      results.newResultSet
        (
        con.createStatement().executeQuery
          (
          "SELECT * FROM [tblMenuItems] WHERE [Item Type]='Extra' ORDER BY Name"
          )
        )
      );
    }

  public String getDessertList() throws Exception
    {
    return
      (
      results.newResultSet
        (
        con.createStatement().executeQuery
          (
          "SELECT * FROM [tblMenuItems] WHERE [Item Type]='Dessert' ORDER BY Name"
          )
        )
      );
    }

  public String getDrinkList() throws Exception
    {
    return
      (
      results.newResultSet
        (
        con.createStatement().executeQuery
          (
          "SELECT * FROM [tblMenuItems] WHERE [Item Type]='Drink' ORDER BY Name"
          )
        )
      );
    }

  public String getMainMealList() throws Exception
    {
    return
      (
      results.newResultSet
        (
        con.createStatement().executeQuery
          (
          "SELECT * FROM [tblMenuItems] WHERE [Item Type]='Main' ORDER BY Name"
          )
        )
      );
    }

  public String getCurrentOrderList() throws Exception
    {
    return
      (
      results.newResultSet
        (
        con.createStatement().executeQuery
          (
          "SELECT * FROM [tblCurrentOrder] WHERE \"Completed\"=False"
          )
        )
      );
    }

  public String getOrderDetails(String OrderID) throws Exception
    {
    return
      (
      results.newResultSet
        (
        con.createStatement().executeQuery
          (
          "SELECT * FROM [tblOrderDetails] WHERE \"Order ID\"="+OrderID
          )
        )
      );
    }
  }

